<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright �2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.reviews_list.php 2203 2008-10-02 09:55:26Z mzanier $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class reviews_list extends products_list {


	/**
	 * Get list with reviews
	 *
	 * @param int $products_id
	 * @return array
	 */
	function getReviewsListing($products_id) {
		global $xtPlugin, $xtLink, $db;


		$products_id = (int)$products_id;
		if ($products_id=='') return false;

		$review = new xt_reviews();

		$query = "SELECT * FROM ".TABLE_PRODUCTS_REVIEWS." WHERE products_id='".$products_id."' and review_status='1'";

		$rs = $db->CacheExecute($query);

		if ($rs->RecordCount()==0) return false;

		$reviews = array();
		while (!$rs->EOF) {
			$reviews[] = $rs->fields;
			$rs->MoveNext();
		}

		// shuffle if more than max
		if (XT_REVIEWS_MAX_DISPLAY_PRODUCTS<$rs->RecordCount()) {
			shuffle($reviews);
			$reviews = array_slice($reviews, 0,XT_REVIEWS_MAX_DISPLAY_PRODUCTS);
		}

		$module_content = array();
		foreach ($reviews as $key => $arr) {
			$arr['review_rating'] = $review->_getStars($arr['review_rating']);
			$customer = new customer($arr['customers_id']);

			$arr['review_editor'] = $customer->customer_default_address['customers_firstname'].' '.substr($customer->customer_default_address['customers_lastname'],0,1).'.';
			$module_content[] = $arr;
		}


		return $module_content;
	}

	function _display($products_id) {
		global $xtPlugin, $xtLink, $db;


		$products_id = (int)$products_id;
		if ($products_id=='') return false;

		$module_content = $this->getReviewsListing($products_id);

		if (!$module_content) return false;
		$tpl_data = array('reviews_data'=>$module_content);

		$tmp_data = '';
		$tpl = 'products_reviews_list.html';
		$template = new Template();
		$template->getTemplatePath($tpl, 'xt_reviews', '', 'plugin');

		$tmp_data = $template->getTemplate('xt_reviews_p_list_smarty', $tpl, $tpl_data);
		return $tmp_data;

	}

}
?>