<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2009 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');


class xt_trusted_shops {
	
	function _validID($id) {
		if (strlen($id)!=33) return false;
		if (substr($id,0,1)!='X') return false;
		return true;	
	}
	
	function _displayIPcheckBox() {
		global $xtPlugin, $xtLink, $db;
		
		$tpl = 'ip_checkbox.html';
		$tmp_data = '';
		$template = new Template();
		$template->getTemplatePath($tpl, 'xt_trusted_shops', '', 'plugin');

		$tmp_data = $template->getTemplate('xt_trusted_shops_smarty', $tpl, $tpl_data);
		return $tmp_data;
		
	}
	
	function _display() {
		global $xtPlugin, $xtLink, $db,$success_order;

		global $language;

		if ($language->code=='de') {
			$shop_id = XT_TRUSTED_SHOPS_KEY_DE;
			$tpl = 'ts_money_back_de.html';
		}
		if ($language->code=='en') {
			$shop_id = XT_TRUSTED_SHOPS_KEY_EN;
			$tpl = 'ts_money_back_en.html';
		}
		if ($language->code=='fr') {
			$shop_id = XT_TRUSTED_SHOPS_KEY_FR;
			$tpl = 'ts_money_back_fr.html';
		}
		
		if (!$this->_validID($shop_id)) return false;

		if (!is_array($success_order->order_data) || $shop_id=='') return false;

		$data = $success_order->order_data;

		$form_fields = array();
		$form_fields['email'] = $data['customers_email_address'];
		$form_fields['first_name'] = $data['delivery_firstname'];
		$form_fields['last_name'] = $data['delivery_lastname'];
		$form_fields['street'] = $data['delivery_street_address'];
		$form_fields['zip'] = $data['delivery_postcode'];
		$form_fields['city'] = $data['delivery_city'];
		$form_fields['country'] = $data['delivery_country_code'];
		$form_fields['phone'] = $data['delivery_phone'];
		$form_fields['amount'] = $success_order->order_total['total']['plain'];
		$form_fields['curr'] = $data['currency_code'];
		$form_fields['KDNR'] = $data['customers_id'];
		$form_fields['ORDERNR'] = $data['orders_id'];


		$tpl_data = array('_form_fields'=>$form_fields,'shop_id'=>$shop_id);

		$tmp_data = '';
		$template = new Template();
		$template->getTemplatePath($tpl, 'xt_trusted_shops', '', 'plugin');

		$tmp_data = $template->getTemplate('xt_trusted_shops_smarty', $tpl, $tpl_data);
		return $tmp_data;

	}

}
?>