<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2009 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.ExtEditForm.php 4177 2010-07-11 20:47:14Z mzanier $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

// lic check
$_lic = _SRV_WEBROOT.'lic/license.txt';
if (!file_exists($_lic)) die ('- VEYTON License File missing (license.txt) -');
    $val_line = '';
    $bline = '';
    $_file_content = file($_lic);
    foreach ($_file_content as $bline_num => $bline) {
        if(ereg('maxversion:', $bline)){
            $val_line = $bline;
            break;
        }
    }

    $val_line = explode(':',$val_line);
    $_max_version = '';
    $_max_version = trim($val_line[1]);
    unset($val_line);
    unset($_lic);
// end license check
//echo $_max_version;
if ($_max_version=='') $_max_version='4012';
if ('4013' > $_max_version) {
    // not allowed to update
    die (' -License not allowed to use Version 4.0.13, your allowed Version is '.$_max_version.' - please contact xt:Commerce Support, helpdesk@xt-commerce.com');
}
// lic check  end

class ExtEditForm extends ExtFunctions {

	function ExtEditForm() {
		
	}

	
	function _getTabLangPanel ($langPanel = null) {
		global $language;
		if (count($this->lang_data) == 0) return false;
        if ($langPanel == null) {
    		$langPanel = new PhpExt_TabPanel();
    		$langPanel->setActiveTab(0)
    		->setDeferredRender(false)
    		->setEnableTabScroll(true)
    		->setDefaults(new PhpExt_Config_ConfigObject(array("autoHeight"=>true,"bodyStyle"=>"padding: 5px; margin:10px","hideMode"=>'offsets')));;
        }
		foreach ($language->_getLanguageList() as $key => $val) {
			if($val['edit']=='1') $langPanel->addItem($this->_getLangPanel($val));
		}
		return $langPanel;
	}
	function _getLangPanel($_lang) {

		$val = $_lang;
		//$gridForm = $extObj;
		$rightPanel = new PhpExt_Panel();
		$rightPanel->setTitle($val['text'])
		->setIconCssClass($val['code'].'_icon')

		->setCollapseFirst(true)
		->setBodyStyle("padding: 5px;")
		->setLayout(new PhpExt_Layout_FormLayout());
		//$rightPanel->setLayout(new PhpExt_Layout_FormLayout());
		foreach ($this->lang_data[$val['code']] as $header_data) {
			$rightPanel->addItem($this->_switchFormField($header_data, $val));
		}

		return $rightPanel;

	}
	function _getEditPanel () {

		$defaultPanel = new PhpExt_Panel();
		$defaultPanel->setTitle(__define("TEXT_DEFAULT"))
		             ->setAutoHeight(true);
		$defaultPanel->setLayout(new PhpExt_Layout_FormLayout())->setBodyStyle("padding: 5px;");
		if (is_array($this->nonlang_data))
		foreach ($this->nonlang_data as $header_data) {
			$defaultPanel->addItem($this->_switchFormField($header_data));
		}

		return $defaultPanel;
	}

	function getAddOn($position) {
		$functions = $this->params['GridEdit']['functions'];

		if (is_array($functions)) {
			$fh = new FunctionHandler();
			$fh->setNoMasterPanel(true);

			foreach ($functions as $val) {

				$group = $val['grouping'];
				if ($group=='0') $group='MAIN';
				if ($group==$position) {
					$fh->setStack($val['value'],$val['type'],$val['grouping']);
				}
			}

			$fh->_getHandler ();
			$jsStack = $fh->_getJsStack ();
		}
		return $jsStack;
	}

	function _getPanelPosition ($position, $paneltext = '', $groupingPosition) {
		$grouping = $this->_getData('editGroupingNonLang');
        $header_data = $this->_getData('headerNonLangData');
        $addon = $this->getAddOn($position, $tabPanel);


        $countPositions = count($groupingPosition) + count($addon);
        if ($countPositions > 1 || $position == 'LANGUAGE') {

	        $tabPanel = new PhpExt_TabPanel();
            $tabPanel->setActiveTab(0)
             		 ->setDeferredRender(false)
             		 ->setEnableTabScroll(true)
            		 ->setDefaults(new PhpExt_Config_ConfigObject(array("autoHeight"=>true,"bodyStyle"=>"margin:20px 10px","hideMode"=>'offsets')));
        }

        if ($position != 'LANGUAGE') {

	        foreach ($groupingPosition as $tabPanelIndex) {
	            if ( $tabPanelIndex != 'languages') {
                $Panel = new PhpExt_Panel();

				$Panel->setTitle(__define("TEXT_".$tabPanelIndex));

			    $Panel->setAutoHeight(true);
			    $Panel->setLayout(new PhpExt_Layout_FormLayout())->setBodyStyle("padding: 5px;");

                if (is_array($grouping[$tabPanelIndex]))
                foreach ($grouping[$tabPanelIndex] as $headerKey) {

				    $Panel->addItem($this->_switchFormField($header_data[$headerKey]));
                }

                if ($countPositions > 1)
                $tabPanel->addItem($Panel);
                else
                $tabPanel = $Panel;
	            }
	        }

            if (is_array($addon[0]))
			foreach ($addon[0] as $nr => $addon_data) {
				$tabPanel->addItem($addon_data);
			}

        } else {
            // langpanel
            $tabPanel = $this->_getTabLangPanel($tabPanel);
        }

        return $tabPanel;
	}



	function _getPanelGroups($form) {

	    $grouping = $this->_getData('editGroupingNonLang');
	    $panelSettings = $this->getSetting('panelSettings');
	    
	    if(is_array($panelSettings) && count($panelSettings)!=0){
		    foreach ($panelSettings as $mainPanel) {
		    	$form->addItem($this->_getPanelPosition($mainPanel['position'], $mainPanel['text'], $mainPanel['groupingPosition']));
		    }
	    }
        return $form;
	}


	function displayEditFormJS ($id) {
		global $language;

		$this->getLayout();
        $settings = $this->getSetting('rowActionsFunctions');
        $menu_settings = $this->getSetting('menuActionsFunctions');
        
		$_sr = $this->_storeEdit($id);
		$store = $_sr['store'];
		$reader = $_sr['reader'];
		// Form Panel
		$form = new PhpExt_Form_FormPanel($this->code.$this->getSelectionItem()."-grideditform") ;
		$form = $this->_getLabelPos($form);

		$form->setLabelWidth($this->getSetting('FormLabelWidth'));
		$form->setReader($reader);

		$form->setBodyStyle("background-color:#efefef; color:#000; padding: 5px;");

		$top = new PhpExt_Toolbar_Toolbar();
		$top = $this->getActionMenu($top);
		$top = $this->getUserMenu($top, 'Toolbar', 'edit');
		
		if (($this->getActivate('image') || $this->getActivate('file') || is_array($settings))) {
    		//$top = new PhpExt_Toolbar_Toolbar();
            $top = $this->getDynamicMenu($top);
            $top = $this->getFileMenu($top);
            
		}
		
		$form->addItem($top);
		
		if ($this->getActivate('image')) {
			$form->addItem($this->getAllImagesPreviewPanel());
		}		
		$form = $this->_getPanelGroups($form);

		// buttons
		$button_panel = new PhpExt_Panel() ;
		$button_panel->setButtonAlign("center");

		if (is_array($settings)) {
		    reset($settings);
		        foreach($settings as $action => $fkt_content) {
		              $Btn = PhpExt_Button::createTextButton(__define('TEXT_'.$action),
		                  new PhpExt_Handler(PhpExt_Javascript::stm($fkt_content)));
		                  $Btn->setIconCssClass($action." x-btn-text ");
                     $button_panel->addButton($Btn);
            }
		}

		$form->addItem($button_panel);

		if($this->checkPermission('edit')) {
			$form->addButton($this->_SubmitButton(__define("BUTTON_SAVE"), __define("TEXT_SAVING"), '-grideditform', 'close'));
			$form->addButton($this->_SubmitButton(__define("BUTTON_UPDATE"), __define("TEXT_SAVING"), '-grideditform', 'update'));
		}
		if($this->checkPermission('cancel')) {
			$form->addButton($this->_CloseButton(__define("BUTTON_CANCEL")));
		}

		if($this->checkPermission('reset'))
		$form->addButton($this->_ResetButton(__define("BUTTON_RESET"), $id));

		$form->setRenderTo(PhpExt_Javascript::variable("Ext.get('".$this->code.$this->getSelectionItem()."-grideditform')"));

		// debug messages
		$this->getDebugMessages ();

		$js = 'var '.$this->getSelectionItem().' = "'.$id.'";' . PhpExt_Ext::onReady(
		$store->getJavascript(false, "store"),

		PhpExt_Javascript::stm(PhpExt_QuickTips::init()),
		PhpExt_Javascript::assign($this->code."bd","Ext.get('".$this->code.$this->getSelectionItem()."-grideditform')"),
		$form->getJavascript(false, $this->code."gridEditForm"),
		$this->add_multimenuactions()
		);
		if(_SYSTEM_USE_WYSIWYG=='TinyMce') {
		  $js.= 'tinyMCE.init(tinyMCESettings); ';
		}
        // UBo++   
        $add_js = $this->getSetting('rowActionsJavascript');
        $js .= $add_js."";
        //UBo--
		return '<script type="text/javascript" charset="utf-8">' . $js . '</script><div id="'.$this->code.$this->getSelectionItem().'-grideditform"></div>';

	}

	function _storeSingle($id) {
		$grid_data = array();
		if ($this->grid_data)
		foreach ($this->grid_data as $key => $data) {
			if ($id == $data[$this->getMasterKey()])
			$grid_data[] = $data;
		}
		//$this->singledata = array(array(1,'b','c'));
		$reader = $this->_reader('Array');
		// Store
		$store = new PhpExt_Data_Store();
		$store->setReader($reader);
		//              ->setData(PhpExt_Javascript::variable("singledata"));
		//		$store->setReader($reader);
		if (count($grid_data) > 0 )
		$store->setData($grid_data);
		return $store;
	}

	// Store
	function _storeEdit($id) {
		$store = new PhpExt_Data_Store();

		$reader = $this->_reader();

		$store->setProxy(new PhpExt_Data_HttpProxy($this->getSetting('readfull_url').'get_data=true'))
		->setReader($reader)
		->setBaseParams(array("limit"=> $this->getSetting('PageSize')));

		return array('store' => $store, 'reader' => $reader);
	}
	function _switchFormField ($line_data, $lang_data = array()) {

		$label = $line_data['name'];
		//		$name = __define($line_data['text']);
		$name = $line_data['text'];
		$value = true;


		switch ($line_data['type']) {
			case "textarea":
				$data = PhpExt_Form_TextArea::createTextArea($label, $name);
				if (isset($line_data['height'])) {
					$data->setHeight($line_data['height']);
				} else {
					$data->setHeight('150');
				}
				if (isset($line_data['width'])) {
					$data->setWidth($line_data['width']);
				} else {
					$data->setWidth('70%');
				}

				break;
			case "admininfo":
				$data = PhpExt_Form_TextArea::createTextArea($label, $name);
				if (isset($line_data['height'])) {
					$data->setHeight($line_data['height']);
				} else {
					$data->setHeight('80');
				}
				if (isset($line_data['width'])) {
					$data->setWidth($line_data['width']);
				} else {
					$data->setWidth('70%');
				}
				$data->setCssClass('form_info');

				break;
			case "htmleditor":

				if(_SYSTEM_USE_WYSIWYG=='SimpleHtmlEditor'){

					$data = PhpExt_Form_HtmlEditor::createHtmlEditor($label, $name);
					break;

				}elseif(_SYSTEM_USE_WYSIWYG=='TinyMce'){
					
 					$data = PhpExt_Form_TextArea::createTextArea($label, $name);
    				$data->setCssClass('TinyMce');
					break;

				}else{

					$data = PhpExt_Form_TextArea::createTextArea($label, $name);
					if (isset($line_data['height'])) {
						$data->setHeight($line_data['height']);
					} else {
						$data->setHeight('150');
					}
					if (isset($line_data['width'])) {
						$data->setWidth($line_data['width']);
					} else {
						$data->setWidth('70%');
					}

					break;
				}

			case "image":
				$uniqueID = $name.'_'.time();

				// dummy field
				$data = PhpExt_Form_Hidden::createHidden($label, $name);

				if (!$line_data['value'])
				$value = false;
				break;
			case "file":
				$uniqueID = $name.'_'.time();
				$data = PhpExt_Form_TextField::createTextField($label, $name, $uniqueID);

				$panel = $this->_fileUploadPanel($data, $uniqueID, $line_data);

				if (!$line_data['value'])
				$value = false;
				break;
			case "date":
				$data = PhpExt_Form_DateField::createDateField($label, $name);
				$data->setFormat('Y-m-d h:i:s');

				break;
			case "dropdown":
				if (empty($line_data['url'])) {
					// default dropdownstatus
					$url = 'DropdownData.php?get=status_truefalse';
				} else {
					$url = $line_data['url'];
				}
				$data = $this->_comboBox($label, $name, $line_data['url']);
				break;
			case "dropdown_ms":
			case "dropdown_multi":
			case "dropdown_multiselect":
				if (empty($line_data['url'])) {
					// default dropdownstatus
					$url = 'DropdownData.php?get=status_truefalse';
				} else {
					$url = $line_data['url'];
				}
				// dropdown with checkbox
				$data = $this->_multiComboBox($label, $name, $line_data['url']);
				break;
			case "itemselect":
				if (empty($line_data['url'])) {
					// default dropdownstatus
					$url = 'DropdownData.php?get=status_truefalse';
				} else {
					$url = $line_data['url'];
				}
				$data = $this->_itemSelect($label, $name, $line_data['url']);
				break;


			case "truefalse": //for admin configuration
			case "status":

				$data = PhpExt_Form_Checkbox::createCheckbox($label, $name);
				$data->setCssClass("checkBox");
				if ($line_data['value'] && $line_data['value'] != 'false')
				$data->setChecked(true);
				else
				$data->setChecked(false);

				// fix: set 'on' value to 1
				$data->setInputValue(1);

				$line_data['required'] = false; // combo not required
				break;
			case "master_key":
				//$data = PhpExt_Form_TextField::createTextField($label, $name);
				//$line_data['required'] = true; // default combo required
				//$data->setDisabled(true);
				//break;

			case "hidden":
				$data = PhpExt_Form_Hidden::createHidden($label, $name);
				$line_data['required'] = false; // not required, user can not enter anything
				break;

			case "password":
				$data = PhpExt_Form_PasswordField::createPasswordField($label,$name);

				break;

			case "upload":
				$data = PhpExt_Form_UploadField::createUploadField($label,$name);
				break;

			default:
				$data = PhpExt_Form_TextField::createTextField($label, $name);
				if (isset($line_data['width'])) {
					$data->setWidth($line_data['width']);
				} else {
					$data->setWidth('300');
				}
				if (isset($line_data['disabled'])) $data->setDisabled(true);

				break;
		}
		////////////////////////////////////////////////////////////////////////
		// field validation
		// readonly
		if ($line_data['readonly'] && !$this->getSetting('edit_masterkey')) {
			$data->setDisabled(true);
		}
		// minimum
		if ($line_data['min']) {
			$data->setMinLength($line_data['min']);
			$data->setMinLengthText(__define("ERROR_MIN"));
		}
		// maximum
		if ($line_data['max']) {
			$data->setMaxLength($line_data['max']);
			$data->setMaxLengthText(__define("ERROR_MAX"));
		}
		// required
		if ($line_data['required']) {
			$data->setAllowBlank(false);
			$data->setBlankText(__define("ERROR_BLANK"));
		}
		// field validation end
		////////////////////////////////////////////////////////////////////////

		// set field value
		if ($value && $line_data['value']!=='' && $line_data['value']!=='0000-00-00 00:00:00') {
			$data->setValue($line_data['value']);
		}
		if ($panel)
		$data = $panel;
		return $data;
	}
	
	
	
}
?>
