<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2009 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.LogHandler.php 3891 2009-11-01 09:28:30Z mzanier $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');


/**
 * System-Log class
 *
 */
class LogHandler extends timer {
	
    protected $_table = TABLE_SYSTEM_LOG;
    protected $_table_lang = null;
    protected $_table_seo = null;
    protected $_master_key = 'log_id';

    function LogHandler() {
		$this->_start();
	}

	/**
	 * display parse time for total page generation
	 *
	 * @param boolean $display
	 * @return string parsetime
	 */
	function parseTime($display = false) {
		$this->_stop();
		if ($display == 'true') {
			return $this->timer_display();
		}
		return false;
	}

	/**
	 * display page parse time
	 *
	 */
	function timer_display() {
		echo '<div class="parseTime">Parse Time: '.$this->timer_total.'s</div>';
	}
	
	/**
	 * add log entry to log table
	 *
	 * @param string $class error class (eg error, success, warning)
	 * @param string $module module/plugin
	 * @param int $identification int identifier for entry (like customers_id etc)
	 * @param array $log_data log data
	 */
	function _addLog($class,$module='',$identification=0,$log_data) {
		global $db;
		
		if (is_array($log_data)) $log_data = serialize($log_data);
		
		$insert_data = array();
		$insert_data['class']=$class;
		$insert_data['module'] = $module;
		$insert_data['identification'] = $identification;
		$insert_data['data'] = $log_data;
		$db->AutoExecute(TABLE_SYSTEM_LOG,$insert_data);
		
		
	}


	/**
	 * send error report mail to administrator
	 * 
	 * using php mail() function
	 *
	 * @param string $line email content
	 * @param string $subject email subject
	 */
	function sendDebugMail($line,$subject){
        
        $headers = 'From: '._CORE_DEBUG_MAIL_ADDRESS. "\r\n" .
    'Reply-To: '._CORE_DEBUG_MAIL_ADDRESS . "\r\n" .
    'X-Mailer: PHP/' . phpversion();
        
		mail(_CORE_DEBUG_MAIL_ADDRESS,$subject,$line,$headers);
	}
    
    function setPosition ($position) {
        $this->position = $position;
    }
    
    function _getParams() {
        $params = array();

        $header['identification'] = array('disabled' => 'true','width'=>'400');
        $header['created'] = array('disabled' => 'true');
        $header['class'] = array('disabled' => 'true');
        $header['module'] = array('disabled' => 'true','width'=>'400');

        $params['header']         = $header;
        $params['master_key']     = $this->_master_key;
        $params['default_sort']   = $this->_master_key;

        $params['display_newBtn'] = false;
        $params['display_deleteBtn'] = false;
        $params['display_editBtn'] = true;
        

        
        if($this->url_data['pg']=='overview' && !$this->url_data['edit_id'] && $this->url_data['new'] != true){
            $params['include'] = array ('log_id','created','module', 'identification', 'class');
        }
        
        return $params;
    }

    function _get($ID = 0) {
        global $xtPlugin, $db, $language;

        if ($this->position != 'admin') return false;

        if ($ID === 'new') {
            $obj = $this->_set(array(), 'new');
            $ID = $obj->new_id;
        }
        
        $ID=(int)$ID;

        $table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key);

        
        if ($this->url_data['get_data']){
            $data = $table_data->getData();
        }elseif($ID){
            $data = $table_data->getData($ID);

            if (strlen($data[0]['data'])>0) {
                $callback_data = unserialize($data[0]['data']);
                $callback = array();
                if (is_array($callback_data)) {
                foreach ($callback_data as $key=>$val) {
                    define('TEXT_DATA_'.strtoupper($key),$key);
                    $callback['data_'.$key] = $val;
                }
                
                unset($data[0]['data']);
                $data[0] = array_merge($data[0],$callback);
                }
            }    
            
        }else{
            $data = $table_data->getHeader();
        }

        $obj = new stdClass;
        $obj->totalCount = count($data);
        $obj->data = $data;

        return $obj;
    }
    
    function _set($ID=0) {
        
        $obj = new stdClass;
        $obj->success = true;
        return $obj;
    
    }
}
?>