<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright �2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.countries.php 4066 2010-03-02 08:47:11Z matthias $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */


defined('_VALID_CALL') or die('Direct Access is not allowed.');

class countries{

	var $default_country = _STORE_COUNTRY;
	var $countries_list = array();
	var $countries_list_sorted = array();

	protected $_table = TABLE_COUNTRIES;
	protected $_table_lang = TABLE_COUNTRIES_DESCRIPTION;
	protected $_table_seo = null;
	protected $_master_key = 'countries_iso_code_2';


	function countries($status=true){
		global $xtPlugin;
		
		($plugin_code = $xtPlugin->PluginCode(__CLASS__.'countries_top')) ? eval($plugin_code) : false;
		if(isset($plugin_return_value))
		return $plugin_return_value;		
		
		
		$this->countries_list = $this->_buildCountryList($status=true);
		$this->countries_list_sorted = $this->_sortList();
		
		($plugin_code = $xtPlugin->PluginCode(__CLASS__.'countries_bottom')) ? eval($plugin_code) : false;
		
	}

	function _buildCountryList($status=true){
		global $db, $language, $xtPlugin;

			if($status == true){
				$sql_qry = " and c.status = 1";
			}

			$qry = "SELECT * FROM " . TABLE_COUNTRIES." c, ".TABLE_COUNTRIES_DESCRIPTION." cd WHERE c.countries_iso_code_2=cd.countries_iso_code_2 and cd.language_code='".$language->code."'".$sql_qry;

			$record = $db->Execute($qry);
				if($record->RecordCount() > 0){
					while(!$record->EOF){

						$record->fields['id'] = $record->fields['countries_iso_code_2'];
						$record->fields['text'] = $record->fields['countries_name'];

						$data[$record->fields['countries_iso_code_2']] = $record->fields;
						
						($plugin_code = $xtPlugin->PluginCode(__CLASS__.'_buildCountryList_data')) ? eval($plugin_code) : false;
						
						
						$record->MoveNext();
					}$record->Close();

					($plugin_code = $xtPlugin->PluginCode(__CLASS__.'_buildCountryList_data_bottom')) ? eval($plugin_code) : false;
					
					return $data;
				}else{
					return false;
				}

	}

	function _getCountryData($country_code){
		global $db, $language, $xtPlugin;

			$record = $db->Execute("SELECT * FROM " . TABLE_COUNTRIES." c, ".TABLE_COUNTRIES_DESCRIPTION." cd where c.countries_iso_code_2 = cd.countries_iso_code_2 and cd.language_code='".$language->code."' and c.countries_iso_code_2 = '".$country_code."' ");
				if($record->RecordCount() > 0){
					while(!$record->EOF){
						$data = $record->fields;
						
						($plugin_code = $xtPlugin->PluginCode(__CLASS__.'_getCountryData_data')) ? eval($plugin_code) : false;
						
						
						$record->MoveNext();
					}$record->Close();
					return $data;
				}else{
					return false;
				}

	}

	function _sortList($sort_key='sort_group', $sort_type='ASC'){

		$data = $this->matrixSort($this->countries_list, $sort_key, $sort_type);

		while (list ($key, $value) = each($data)) {

			$step_1_data[$value['sort_group']][] = $value;

		}

			$tmp_step_1_data = $step_1_data;

		while (list ($key, $value) = each($tmp_step_1_data)) {

			$step_2_data[$key] = $this->matrixSort($value, 'countries_name', $sort_type);

		}

			$tmp_step_2_data = $step_2_data;

		while (list ($key, $value) = each($tmp_step_2_data)) {

			$tmp_step_3_data = $value;

			while (list ($key, $value) = each($tmp_step_3_data)) {
				$new_data[] = $value;
			}

		}

		return $new_data;
	}


	 function matrixSort(&$matrix,$sortKey,$sort = 'ASC') {
	  if (count($matrix) == 0) return false;

	  foreach($matrix as $key => $subMatrix){
	  	$tmpArray[$key]=$subMatrix[$sortKey];
	  }

		arsort($tmpArray);

	    while(list($key, $value)=each($tmpArray))
	      $ArrayNew[$key]=$matrix[$key];

	      if ($sort == 'ASC')
	  		$ArrayNew = array_reverse($ArrayNew);

	   return $ArrayNew;

	 }


	function setPosition ($position) {
		$this->position = $position;
	}

	function _getParams() {
		global $language;


		$params = array();

		$header['countries_iso_code_3'] = array('max' => '3','min'=>'3');
		$header['zone_id'] = array(
									'type' => 'dropdown', 								// you can modyfy the auto type
									'url'  => 'DropdownData.php?get=tax_zones');

		$params['header']         = $header;
		$params['master_key']     = $this->_master_key;
		$params['default_sort']   = 'countries_name_'.$language->code;

		$params['display_newBtn'] = false;
        $params['display_deleteBtn'] = false;
		$params['display_checkCol']  = true;
		$params['display_statusTrueBtn']  = true;
		$params['display_statusFalseBtn']  = true;

		/* grouping params */
		//$params['GroupField']     = "zone_id";
		//$params['SortField']      = $this->_master_key;
		//$params['SortDir']        = "ASC";
		/* grouping params end */

		//$params['exclude']        = array ('link', 'text');

		return $params;
	}

	function _get($ID = 0) {
		global $xtPlugin, $db, $language;

		if ($this->position != 'admin') return false;

		if (!$ID && !isset($this->sql_limit)) {
			$this->sql_limit = "0,25";
		}		
		
		$table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key, '', $this->sql_limit);

		if ($this->url_data['get_data']){
        $data = $table_data->getData();
		}elseif($ID){
        $data = $table_data->getData($ID);
			foreach ($language->_getLanguageList() as $key => $val) {
				$data[0]['countries_name_'.$val['code']] = _filterText($data[0]['countries_name_'.$val['code']]);
			}

        }else{
		$data = $table_data->getHeader();
        }

		if($table_data->_total_count!=0 || !$table_data->_total_count)
		$count_data = $table_data->_total_count;
		else
		$count_data = count($data);

		$obj->totalCount = $count_data;
		$obj->data = $data;

		return $obj;

	}

	function _set($data, $set_type='edit'){
		global $db,$language,$filter;

		 $obj = new stdClass;

		 $oC = new adminDB_DataSave(TABLE_COUNTRIES, $data);
		 $objC = $oC->saveDataSet();

		 $oCD = new adminDB_DataSave(TABLE_COUNTRIES_DESCRIPTION, $data, true);
		 $objCD = $oCD->saveDataSet();

		 if ($objC->success && $objCD->success) {
		     $obj->success = true;
		 } else {
		     $obj->failed = true;
		 }

		return $obj;
	}

	function _unset($id = 0) {
	    return false;
        global $db;
	    if ($id == 0) return false;
		if ($this->position != 'admin') return false;

	    $db->Execute("DELETE FROM ". TABLE_COUNTRIES ." WHERE ".$this->_master_key." = ".$id);
	    $db->Execute("DELETE FROM ". TABLE_COUNTRIES_DESCRIPTION ." WHERE ".$this->_master_key." = ".$id);

	}

	function _setStatus($id, $status) {
		global $db,$xtPlugin;

		$db->Execute("update " . TABLE_COUNTRIES . " set status = ".$status." where countries_iso_code_2 = '" . $id . "'");

	}
}
?>
