<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2009 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.download.php 4296 2010-08-20 11:30:52Z uboeckers $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');



class download {


	var $safe_dir = 'media/files/';
	var $public_dir = 'media/files_public/';


	/**
	 * delete all out-of-time symlinks
	 *
	 */
	function _deleteOutOfDateLinks() {
		global $db;

		$rs = $db->Execute("SELECT * FROM ".TABLE_MEDIA_SYMLINK." WHERE symlink_valid<".$db->DBTimeStamp(time()));
		if ($rs->RecordCount()>0) {
			while (!$rs->EOF) {
				$dir = _SRV_WEBROOT.'media/files_public/'.$rs->fields['symlink_dir'];
				if (is_dir($dir)) $this->remove_dir($dir);
				$db->Execute("DELETE FROM ".TABLE_MEDIA_SYMLINK." WHERE symlink_id='".$rs->fields['symlink_id']."'");
				$rs->MoveNext();
			}
		}

	}

	/**
	 * Remove dir with subdirectories and files
	 *
	 * @param string $dir
	 */
	function remove_dir($dir) {
		$handle = opendir($dir);
		while ($file = readdir($handle)) {
			if(!in_array($file, array(".", "..")))
			{
				if(!is_dir($dir.$file))
				@unlink($dir.$file);
				else
				remove_dir($dir.$file);
			}
		}
		closedir($handle);
		@rmdir($dir);
	}

	function servePublicFile($media_id) {
		global $db,$xtLink,$info,$current_product_id;

		$media_id = (int)$media_id;

		$med_perm_array =array('group_perm' => array('type'=>'group_permission','key'=>'id','value_type'=>'media_file','pref'=>'m'));

		$med_permission = new item_permission($med_perm_array);

		$qry = "SELECT distinct m.* FROM ".TABLE_MEDIA." m ".$med_permission->_table." where m.id='".$media_id."'".$med_permission->_where." and m.download_status = 'free' and m.status = 'true'";
		$rs = $db->Execute($qry);

		if ($rs->RecordCount()!=1) {
			$tmp_link  = $xtLink->_link(array('page'=>'product','info'=>$current_product_id));
			$info->_addInfoSession(ERROR_DOWNLOAD,'error');
			$xtLink->_redirect($tmp_link);

		} else {

			if ($this->fileExists($rs->fields['file'],$current_product_id)) {

				$dir = $this->generateRandString();
				$this->createPublicDir($dir);
				$this->_addSymlinkLog($dir);
					
				//symlink(_SRV_WEBROOT.$this->safe_dir . $rs->fields['file'], _SRV_WEBROOT.$this->public_dir . $dir . "/" . $rs->fields['file']);
				$this->_createSymlink($rs->fields['file'],$dir);

				Header("Location: " .  _SRV_WEB.$this->public_dir . $dir . "/" . $rs->fields['file']);


			}


		}


	}

	function serveFile($order_id,$media_id) {
		global $db,$xtLink,$info;

		$order_id = (int)$order_id;
		$media_id = (int)$media_id;

		if (!is_int($order_id)) return false;
		if (!is_int($media_id)) return false;
		// check if allowed for download
		$query = "SELECT m.*,o.*,opm.* FROM ".TABLE_ORDERS_PRODUCTS_MEDIA." opm INNER JOIN ".TABLE_ORDERS." o ON opm.orders_id=o.orders_id INNER JOIN ".TABLE_MEDIA." m ON m.id=opm.media_id WHERE opm.orders_id='".$order_id."' and opm.media_id='".$media_id."' and o.customers_id='".(int)$_SESSION['registered_customer']."'";
		$rs = $db->Execute($query);

		if ($rs->RecordCount()!='1') {

			$tmp_link  = $xtLink->_link(array('page'=>'customer','paction'=>'download_overview'));
			$info->_addInfoSession(ERROR_DOWNLOAD,'error');
			$xtLink->_redirect($tmp_link);

		} else {

			// check if allowed ?
			if (!$this->_checkDowloadAllowed($rs->fields['date_purchased'],$rs->fields['max_dl_days'],$rs->fields['max_dl_count'],$rs->fields['download_count']))
			return false;

			if ($this->fileExists($rs->fields['file'],$rs->fields['orders_id'])) {

				$dir = $this->generateRandString();
				$this->createPublicDir($dir);
				$this->_addSymlinkLog($dir);
					

				$this->_createSymlink($rs->fields['file'],$dir);

				$this->addCount($rs->fields['orders_id'],$rs->fields['media_id']);
					
				Header("Location: " .  _SRV_WEB.$this->public_dir . $dir . "/" . $rs->fields['file']);


			}

		}

	}
	
	/**
	 * create symlink using WEBROOT or DOCUMENT_ROOT dir
	 * @param $file
	 * @param $tmp_dir
	 * @return unknown_type
	 */
	function _createSymlink($file,$tmp_dir) {
		global $logHandler;

		$dir = _SRV_WEBROOT;
        $dir_2 = $_SERVER['DOCUMENT_ROOT'];

        if (file_exists($dir.$this->safe_dir . $file)) {
          $dir = $dir; 

        } elseif($dir_2.$this->safe_dir . $file){
          $dir = $dir_2;  

        } else {

           $log_data = array();
           $log_data['error'] = 'no file found';
           $logHandler->_addLog('error','download','0',$log_data); 
        }

		symlink($dir.$this->safe_dir . $file, $dir.$this->public_dir . $tmp_dir . "/" . $file);
		
	}

	/**
	 * add log entry to media_symlink table
	 *
	 * @param string $dir
	 */
	function _addSymlinkLog($dir) {
		global $db;

		$path_array = array();
		$path_array['symlink_dir'] = $dir;
		$path_array['symlink_valid'] = date_add_hours(time(),2);
		$db->AutoExecute(TABLE_MEDIA_SYMLINK,$path_array);
	}

	/**
	 * set download counter +1
	 *
	 * @param int $order_id
	 * @param int $media_id
	 */
	function addCount($order_id,$media_id) {
		global $db;

		$order_id = (int)$order_id;
		$media_id = (int)$media_id;

		$db->Execute("UPDATE ".TABLE_ORDERS_PRODUCTS_MEDIA." SET download_count=download_count+1 WHERE orders_id='".$order_id."' and media_id='".$media_id."'");

	}

	function generateRandString() {
		$allowedChars = 'abcdefghijklmnopqrstuvwxyz';
		srand((double) microtime() * 1000000);
		$string = '';
		for ($i = 1; $i <= rand(8,12); $i++) {
			$q = rand(1,24);
			$string = $string . $allowedChars[$q];
		}

		return $string;
	}

	/**
	 * check if download file exists (original), add log entry if failed
	 *
	 * @param string $file
	 * @param int $orders_id
	 * @return boolean
	 */
	function fileExists($file,$orders_id) {
		global $logHandler;
		if (!file_exists(_SRV_WEBROOT.$this->safe_dir.$file)) {
			$log_data = array();
			$log_data['file_not_exists'] = $file;
			$logHandler->_addLog('error','download_system',$orders_id,$log_data);
			return false;
		}
		return true;


	}

	/**
	 * create dir in files_public folder
	 *
	 * @param unknown_type $dir
	 */
	function createPublicDir($dir) {
		umask(0000);
        mkdir(_SRV_WEBROOT.$this->public_dir.$dir,0777);
	}


	/**
	 * check if download is allowed (date range, count)
	 *
	 * @param datetime $date
	 * @param int $days
	 * @param int $count_max
	 * @param int $count_loaded
	 * @return boolean
	 */
	function _checkDowloadAllowed($date,$days=0,$count_max=0,$count_loaded=0) {

		$count_left = $count_max-$count_loaded;
		$date_until = vtn_date_add(datetime_to_timestamp($date),$days);
		$diff = time()-$date_until;

		// count
		if ($count_left<=0 && $count_max>0) return false;

		// date
		if ($days>0) {
			if ($diff>0) return false;
		}

		return true;

	}
}
?>