<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright ?2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.links.php 4275 2010-08-11 09:38:00Z uboeckers $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH    mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche                    mh@xt-commerce.com
 # @author Matthias Benkwitz                mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class xtLink{

    var $xtLink;
    var $params;
    var $GET_PARAMS = array();
    var $link_url;
    var $secure_link_url;

    function xtLink(){
        global $xtPlugin;

        $this->amp = '&amp;';
        $this->show_session_id = _RMV_SESSION;

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:link_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;

    }

    function showSessionID($val){
        $this->show_session_id = $val;
    }
    
    function setLinkURL($url=''){
        $this->link_url = $url;
    }
    
    function setSecureLinkURL($surl=''){
        $this->secure_link_url = $surl;
    }    
    
    function unsetLinkURL(){
        unset($this->link_url);
    }
    
    function unsetSecureLinkURL(){
        unset($this->secure_link_url);
    }    
    
    function _link($data,$remove_dir=''){
        global $xtPlugin, $page,$remove_session, $language;
        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_link_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;
        
        if(empty($data['default_page'])){
            $default_page = 'index.php';
        }else{
            $default_page = $data['default_page'];
        }
        
        if(empty($this->link_url)){
            $system_http_link = _SYSTEM_BASE_HTTP;
        }else{
            $system_http_link = $this->link_url;
        }        
        
        if(empty($this->secure_link_url)){
            $system_https_link = _SYSTEM_BASE_HTTPS;
        }else{
            $system_https_link = $this->secure_link_url;
        }        
        
        if (!isset($data['conn'])) $data['conn']='NOSSL';
        if($data['conn'] == 'SSL' && _SYSTEM_SSL == true){
            $link_data = $system_https_link._SRV_WEB;
        }else{
            $link_data = $system_http_link._SRV_WEB;
        }
        
        if ($remove_dir!='') $link_data =str_replace($remove_dir,'',$link_data);
        // change for single domain - multistore
       // if (_SYSTEM_BASE_VIRTUAL_FOLDER!='') $link_data.=_SYSTEM_BASE_VIRTUAL_FOLDER.'/'; deaktivated, virt folders
        if ((_SYSTEM_MOD_REWRITE == 'true') && ($data['seo_url']!='')) {  // seo_url verwenden 
               $link_data.=$data['seo_url'];
            
                if(_SYSTEM_SEO_FILE_TYPE!=''){
                   $link_data = $link_data.'.'._SYSTEM_SEO_FILE_TYPE;
                }
                if (_RMV_SESSION=='false') {     
                    if (!isset($_COOKIE[session_name()])) $link_data .='?'.session_name().'='.session_id();
                }
                return $link_data;    
            
        } else if((_SYSTEM_MOD_REWRITE == 'true') && (_SYSTEM_MOD_REWRITE_DEFAULT == 'true')) {  // default SEO-URL zusammenbauen
              if((empty($data['default_page'])) && (_SYSTEM_SEO_URL_LANG_BASED == 'true')) {
                 if(trim($data['lang_code']) != '') {
                   $link_data .= $data['lang_code'].'/';                
                 } else {
                   $link_data .= $language->code.'/';                
                 }   
              }
                // page
                if($data['page']=='dynamic'){
                    $link_data .= $page->page_name;
                }else{
                    if((empty($data['page'])) && (!empty($default_page))) {
                        $link_data .= $default_page;
                    } else {
                        $link_data .= $data['page'];
                    }
                }

                // page_action
                if($data['page']=='dynamic'){
                    if(!empty($data['paction']))
                    $link_data .= '/'.$page->page_action;
                }else{
                    if(!empty($data['paction']))
                    $link_data .= '/'.$data['paction'];
                }            
                if((empty($data['default_page'])) && (_SYSTEM_SEO_FILE_TYPE != '')){
                  $link_data .= '.'._SYSTEM_SEO_FILE_TYPE;
                } else {
//                  $link_data .= '.html';
                }
                
                // wegen mglicher weiterer Parameter
                $link_data .= '?';
                
                
//            }
        } else { // No SEO
            if(!empty($data['pos']))
            $link_data .= $data['pos'];

            // page
            if($data['page']=='dynamic'){
                $link_data .= $default_page.'?page='.$page->page_name;
            }else{
                $link_data .= $default_page.'?page='.$data['page'];
            }

            // page_action
            if($data['page']=='dynamic'){

                if(!empty($data['paction']))
                $link_data .= $this->amp.'page_action='.$page->page_action;

            }else{

                if(!empty($data['paction']))
                $link_data .= $this->amp.'page_action='.$data['paction'];

            }
        }

        $exclude_array = array();
        $data_exclude = array();
        
        if(!empty($data['params'])){

            $data['params'] = str_replace($this->amp, '&',$data['params']);

            $data['params'] = str_replace('&',$this->amp,$data['params']);    
            $data['params']=$this->amp.$data['params'];
    
        }

        $link_data .= $data['params'];
        
        if(!empty($data['name']) && !empty($data['type']) && !empty($data['id']))
        $link_data .= $this->amp.$this->_linkTypes($data['type'], $data['id'], $data['name']);

        // add session ?
        if ($this->show_session_id=='false') {
            if (!isset($_COOKIE[session_name()])) $link_data .=$this->amp.session_name().'='.session_id();
        }

        // add to SSL Link (for ssl proxies)
        if($data['conn'] == 'SSL' && _SYSTEM_SSL == true){
            if (!strpos($link_data,session_name())) {

                preg_match('@^(?:https://)?([^/]+)@i',_SYSTEM_BASE_HTTPS, $treffer);
                $https = $treffer[1];

                preg_match('@^(?:http://)?([^/]+)@i',_SYSTEM_BASE_HTTP, $treffer);
                $http = $treffer[1];
                if ($https!=$http)
                    $link_data .=$this->amp.session_name().'='.session_id();
            }
        }
        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_link_bottom')) ? eval($plugin_code) : false;
        $link_data = ereg_replace($this->amp.$this->amp,$this->amp,$link_data);
        //$link_data = ereg_replace('&&', '&',$link_data);
        //__debug($link_data, 'LINK Data:');

        
        // UBo++
        $link_data = str_replace('?'.$this->amp,'?',$link_data);
        //$link_data = rtrim($link_data, '?'.$this->amp);
        // check for last chars in url, if ?, & or $this->amp
        if (substr($link_data, -1)=='?' or substr($link_data, -1)=='&') {
           $link_data = substr($link_data,0,-1);  
        } elseif(substr($link_data, -4)==$this->amp) {
           $link_data = substr($link_data,0,-4);  
        }
        
        // UBo--

        
        return $link_data;

    }

    function _storelink($data){
        global $xtPlugin;

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_adminlink_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;

        $data['pos'] = _SRV_WEB_ADMIN;

        return $this->_link($data);

    }

    function _adminlink($data){
        global $xtPlugin;

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_adminlink_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;

        return $this->_link($data,'xtAdmin/');

    }


    function _redirect($url){
        global $xtPlugin;

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_redirect_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;


        $url = eregi_replace("[\r\n]+(.*)$", "", $url);

        $url = html_entity_decode($url);

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_redirect_bottom')) ? eval($plugin_code) : false;
        header('Location: ' . $url);
        exit();
        // close session and exit
        //session_close();
        //exit();

    }


    function _cleanData($data){
        global $xtPlugin;

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_cleanData_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;

        $search_array=    array('ä',    'Ä',    'ö',    'Ö',    'ü',    'Ü',    '&auml;',    '&Auml;',    '&ouml;',    '&Ouml;',    '&uuml;',    '&Uuml;');
        $replace_array=    array('ae',    'Ae',    'oe',    'Oe',    'ue',    'Ue',    'ae',        'Ae',        'oe',        'Oe',        'ue',                    'Ue');

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_cleanData_arrays')) ? eval($plugin_code) : false;

        $data=str_replace($search_array,$replace_array,$data);

        $replace_param='/[^a-zA-Z0-9]/';
        $data=preg_replace($replace_param,'-',$data);

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_cleanData_bottom')) ? eval($plugin_code) : false;
        return $data;

    }

    function _linkTypes($type, $id, $name){
        global $xtPlugin;

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_linkTypes_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;

        if($type=='category'){
            //$name = $this->_cleanData($name);
            $link_data = 'cat='.$id;
        }

        if($type=='product'){
            //$name = $this->_cleanData($name);
            $link_data = 'info='.$id;
        }

        if($type=='manufacturer'){
            //$name = $this->_cleanData($name);
            $link_data = 'mnf='.$id;
        }


        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_linkTypes_bottom')) ? eval($plugin_code) : false;
        return $link_data;
    }

    function _getParams($exclude = '') {
        global $xtPlugin;

        $data_array = array();
        $data_array = $_GET;
        reset($data_array);

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_getParams_top')) ? eval($plugin_code) : false;
        if(isset($plugin_return_value))
        return $plugin_return_value;


        if (!is_array($exclude)) $exclude = array();
        $default_exclude = array();
        $default_exclude = array('page', 'x', 'y', 'next_page', 'page_action');
        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_getParams_exclude')) ? eval($plugin_code) : false;

        $exclude = array_merge($exclude, $default_exclude);
        
        $url = array();
        if (is_array($data_array) && (sizeof($data_array) > 0)) {
            while (list($key, $value) = each($data_array)) {
    
                if ( (strlen($value) > 0) && (!in_array($key, $exclude))) {
                    $url[]= $key . '=' . $value;
                }
            }
        }

        $url = implode($this->amp,$url);

        ($plugin_code = $xtPlugin->PluginCode('class.link.php:_getParams_bottom')) ? eval($plugin_code) : false;
        return $url;
    }

}
?>