<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.manufacturer_sql_query.php 3964 2010-01-14 09:42:49Z mb $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class getManufacturerSQL_query extends SQL_query{
	var $filterFunctions; // sql filter functions array
	var $a_sql_table, $a_sql_where, $a_sql_sort, $a_sql_group;

	function getManufacturerSQL_query() {
		global $xtPlugin;
		
		$this->setSQL_TABLE(TABLE_MANUFACTURERS . " m ");
		$this->setSQL_WHERE(" m.manufacturers_id != '0'");
		
		($plugin_code = $xtPlugin->PluginCode(__CLASS__.':class_top')) ? eval($plugin_code) : false;

	}

	function getSQL_query($sql_cols = 'm.manufacturers_id') {
		
		if(USER_POSITION=='store')
		$this->setFilter('StoreCheck');
		
		$this->getFilter();
		$this->getHooks();

		$sql = 'SELECT '.$sql_cols.$this->a_sql_cols.' FROM '.$this->a_sql_table;
		if (is_data($this->a_sql_where))
			$sql.=' WHERE '.$this->a_sql_where;
		if (is_data($this->a_sql_group))
			$sql.=' GROUP BY '.$this->a_sql_group;
		if (is_data($this->a_sql_sort))
			$sql.=' ORDER BY '.$this->a_sql_sort;
		if (is_data($this->a_sql_limit))
			$sql.=' LIMIT '.$this->a_sql_limit;
		return $sql;
	}

	//////////////////////////////////////////////////////
	// mnf filter function
	
	function F_Seo($lang_code='') {
		global $language;

		if(empty($lang_code))
			$lang_code = $language->code;

		$this->setSQL_TABLE("LEFT JOIN " . TABLE_SEO_URL . " su ON (m.manufacturers_id = su.link_id and su.link_type='4')");
		$this->setSQL_WHERE("and su.language_code = '" . $lang_code . "' ");

	}

	function F_Language($lang_code=''){
		global $language;

		if(empty($lang_code))
			$lang_code = $language->code;

		$this->setSQL_TABLE("LEFT JOIN " . TABLE_MANUFACTURERS_DESCRIPTION . " mi ON m.manufacturers_id = mi.manufacturers_id");
		$this->setSQL_WHERE("and mi.language_code = '" . $lang_code . "' ");
	}

	function F_Sorting($sort) {
			switch ($sort) {

			case 'name' :
				$this->setSQL_SORT(' m.manufacturers_name');
				break;

			case 'name-desc' :
				$this->setSQL_SORT(' m.manufacturers_name DESC');
				break;

			default:
				return false;
		}
	}

	function F_StoreCheck () {
		global $store_handler;

		if (_SYSTEM_GROUP_CHECK == 'true' && isset($store_handler->shop_id)) {
			$perm_array = array(array('type'=>'shop',
									  'table'=>TABLE_MANUFACTURERS_PERMISSION,
									  'key'=>'manufacturers_id',
									  'pref'=>'m'
									 ));

			$perm = new item_permission($perm_array);

			$this->setSQL_TABLE($perm->_table);
			$this->setSQL_WHERE($perm->_where);
		}
	}	
	
	function F_MultiCheck ($params='') {
		global $xtPlugin;

	    ($plugin_code = $xtPlugin->PluginCode(__CLASS__.':F_MultiCheck')) ? eval($plugin_code) : false;
		
	}		
	
	function F_GroupCheck () {
	 global $customers_status;
	
	 if (_SYSTEM_GROUP_CHECK == 'true' && isset($customers_status->customers_status_id)) {
	
	  $perm_array = array(array('type'=>'group_permission',
	          'table'=>TABLE_PRODUCTS_PERMISSION,
	          'simple_permissions_table'=>TABLE_CATEGORIES_PERMISSION,
	          'key'=>'products_id',
	          'simple_permissions' => 'true',
	          'simple_permissions_key' => 'permission_id',
	          'pref'=>'p'
	         ));
	
	  $perm = new item_permission($perm_array);
	
	  $this->setSQL_TABLE($perm->_table);
	  $this->setSQL_WHERE($perm->_where);
	 }
	}	
	
	// mnf filter function
	//////////////////////////////////////////////////////

}

?>