<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright ©2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.meta_tags.php 3855 2009-10-10 17:06:55Z mzanier $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class meta_tags {

	var $minWordlength = _SYSTEM_METATAGS_WORDLENGTH;
	var $maxMetaKeyLength = _SYSTEM_METATAGS_MAXLENGTH;
	var $maxMetaKeyCount = _SYSTEM_METATAGS_MAXCOUNT;

	function meta_tags() {
		global $language,$p_info;

		$this->tags = array ();
		$this->tags['robots'] = _STORE_META_ROBOTS;
		$this->tags['language'] = $language->code;
		$this->tags['company'] = _STORE_META_COMPANY;
		$this->tags['author'] = _STORE_META_AUTHOR;
		$this->tags['publisher'] = _STORE_META_PUBLISHER;
		$this->tags['page-topic'] = _STORE_META_TOPIC;
		$this->tags['reply-to'] = _STORE_META_REPLY_TO;
		$this->tags['revisit-after'] = _STORE_META_REVISIT_AFTER;
		$this->tags['description'] = _STORE_META_DESCRIPTION;
		$this->tags['keywords'] = _STORE_META_KEYWORDS;
		$this->pageTitle = _STORE_NAME;
        $this->autogenerate = false;
		$this->generateTags();
	}
	
	function generateTags() {
		global $xtPlugin, $page;	
		//echo $page->page_name;
		switch ($page->page_name) {

			case 'product' :
				global $p_info;
     //           debugbreak();
				if ($p_info->data['meta_keywords'] != '') {
					$this->tags['keywords'] = $p_info->data['meta_keywords'];
				} else {
					$this->tags['keywords'] = $this->_autoGenerateTags($p_info->data['products_description']);
				}
				if ($p_info->data['meta_title'] != '') {
					$this->pageTitle = $p_info->data['meta_title'];
				} else {
					$this->pageTitle = $p_info->data['products_name'] . '-' . $p_info->data['products_model'];
				}
				if ($p_info->data['meta_description'] != '') {
					$this->tags['description'] = $p_info->data['meta_description'];
				}
				break;

			case 'categorie' :
				global $category;
				if ($category->current_category_data['meta_keywords'] != '') {
					$this->tags['keywords'] = $category->current_category_data['meta_keywords'];
				} else {
					if ($category->current_category_data['categories_description'] != '') {
						$this->tags['keywords'] = $this->_autoGenerateTags($category->current_category_data['categories_description']);
					} else {
						$this->autogenerate=true;
					}
				}
				if ($category->current_category_data['meta_title'] != '') {
					$this->pageTitle = $category->current_category_data['meta_title'];
				} else {
					$this->pageTitle = $category->current_category_data['categories_name'];
				}
				if ($category->current_category_data['meta_description'] != '') {
					$this->tags['description'] = $category->current_category_data['meta_description'];
				}

				break;

			case 'content';
			global $_content,$current_content_id;
			$shop_content_data =  $_content->getHookContent($current_content_id, 'true');
			if ($shop_content_data['meta_title'] != '') {
				$this->pageTitle  = $shop_content_data['meta_title'];
			} else {
				$this->pageTitle  = $shop_content_data['title'];
			}
			if ($shop_content_data['meta_keywords'] != '') {
				$this->tags['keywords'] = $shop_content_data['meta_keywords'];
			} else {
				$this->tags['keywords'] = $this->_autoGenerateTags($shop_content_data['content_body']);
			}
			if ($shop_content_data['meta_description'] != '') {
				$this->tags['description'] = $shop_content_data['meta_description'];
			}

			break;
            
            case 'manufacturers':
            global $man_data,$current_manufacturer_id,$manufacturer;
            
            $man_data = $manufacturer->getManufacturerData($current_manufacturer_id); 

            if ($man_data['meta_title'] != '') {
                $this->pageTitle  = $man_data['meta_title'];
            } else {
                $this->pageTitle  = $man_data['manufacturers_name'];
            }
            if ($man_data['meta_keywords'] != '') {
                $this->tags['keywords'] = $man_data['meta_keywords'];
            } else {
                $this->autogenerate=true;
            }
            if ($man_data['meta_description'] != '') {
                $this->tags['description'] = $man_data['meta_description'];
            }               
            
            break;

			default :
				if (_STORE_META_KEYWORDS=='') $this->tags['keywords'] = $this->_autoGenerateTags($this->PageContent);
				break;

		}		
		($plugin_code = $xtPlugin->PluginCode('class.meta_tags.php:'.__METHOD__.'_bottom')) ? eval ($plugin_code) : false;
		
		
	}
	

	function _showTags($page_content='') {
		global $xtPlugin, $page,$no_index_tag;
		//	echo $page->page_name;
		$this->PageContent=$page_content;

         if ($no_index_tag) {
            $this->tags['robots'] = 'noindex';
         }
         if ($this->autogenerate && _SYSTEM_METATAGS_AUTOGENERATE=='true') {
             $this->tags['keywords'] = $this->_autoGenerateTags($this->PageContent);
         } 
		($plugin_code = $xtPlugin->PluginCode('class.meta_tags.php:_showTags_bottom')) ? eval ($plugin_code) : false;
		echo '<title>' . htmlspecialchars($this->pageTitle) . "</title>\n";
		($plugin_code = $xtPlugin->PluginCode('class.meta_tags.php:icra')) ? eval ($plugin_code) : false;
		foreach ($this->tags as $name => $content) {
			if (!empty ($content))
			echo '<meta name="' . $name . '" content="' . $content . '" />' . "\n";
		}
        echo '<meta name="generator" content="xt:Commerce VEYTON '._SYSTEM_VERSION.'" />' . "\n";
			echo stripslashes(_STORE_META_FREE_META);
	}
/*
	// function inspired from http://at.php.net/get_html_translation_table 04-jun-2007
	function unhtmlentities ($string)  {
		$trans_tbl = get_html_translation_table (HTML_ENTITIES);
		$trans_tbl = array_flip ($trans_tbl);
		$ret = strtr ($string, $trans_tbl);
		return  preg_replace('/\&\#([0-9]+)\;/me',
        "chr('\\1')",$ret);
	}
*/
	// function inspired from http://at.php.net/get_html_translation_table 04-jun-2007
	function unhtmlentities ($string)  {
		$ret = html_entity_decode($string, ENT_QUOTES, "UTF-8");
		return $ret;
	}

	function _autoGenerateTags($text) {

	    $text = preg_replace(
        array(
            '@<head[^>]*?>.*?</head>@siu',
            '@<style[^>]*?>.*?</style>@siu',
            '@<script[^>]*?.*?</script>@siu',
            '@<object[^>]*?.*?</object>@siu',
            '@<embed[^>]*?.*?</embed>@siu',
            '@<applet[^>]*?.*?</applet>@siu',
            '@<noframes[^>]*?.*?</noframes>@siu',
            '@<noscript[^>]*?.*?</noscript>@siu',
            '@<noembed[^>]*?.*?</noembed>@siu',
        ),
        array(
            ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',
        ),
        $text );

		// remove html
		$text = strip_tags($text);
		$text = $this->unhtmlentities($text);

		$trash = array (
			',',
			'.',
			'(',
			')',
			'[',
			']',
			'{',
			'}',
			"'",
			'"',
			'<',
			'>',
			':',
			'?',
			'!',
			'/',
			'\\',
			'_',
			'+',
			'-',
			'*',
			'=',
			'#',
			'&quot;',
			'&copy;',
			'&gt;',
		    '&nbsp;',
		    '\t',
		    '\r',
		    '\n',
		    '\b',
			'&lt;',chr(10), chr(13), chr(9)


		);

		$text = str_replace($trash, ' ', $text);

		$words = explode(" ", $text);
		$selected = array ();
		$skip = SYSTEM_METATAGS_BLACKLIST;
		$skip = explode(',', $skip);
		foreach ($words as $key => $val) {

			//$val = preg_replace('/[^a-zA-Z0-9_-äÄöÖüÜ]/u', '_', $val);

			if (strlen($val) >= $this->minWordlength && !is_int($val) && !in_array($val, $skip)) {
				if (isset ($selected[$val])) {
					$count = 1;
					$selected[$val]['count']++;
				} else {
					$selected[$val] = array (
						'word' => $val,
						'count' => 1
					);
				}
			}
		}
		$count = array ();
		foreach ($selected as $key => $row) {
			$count[$key] = $row['count'];
		}
		// sort on word count
		array_multisort($count, SORT_DESC, $selected);

		// generate tag
		$tags = array ();
		$length = 0;
		foreach ($selected as $key => $row) {
			if (($length +strlen($row['word']) + 1) < $this->maxMetaKeyLength && $this->maxMetaKeyCount >= count($tags)) {
				$tags[] = $row['word'];
				$length += strlen($row['word']) + 1;
			}
		}
		return implode(',', $tags);
	}
    


}
?>