<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright �2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.product_to_cat.php 4183 2010-07-12 18:00:30Z mhinsche $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */


defined('_VALID_CALL') or die('Direct Access is not allowed.');

require_once(_SRV_WEBROOT._SRV_WEB_FRAMEWORK.'classes/class.recursive.php');
class product_to_cat extends product {

	public $_table = TABLE_PRODUCTS_TO_CATEGORIES;
	public $_table_lang = TABLE_CATEGORIES_DESCRIPTION;
	public $_table_seo = null;
	public $_master_key = 'categories_id';
    protected $_icons_path = "images/icons/";

    function __construct() {
       parent::__construct();
       $this->indexID = time().'-Prod2Cat';

       $this->getTreeUrl = 'adminHandler.php?load_section=product_to_cat&pg=getNode&';
       $this->getSaveUrl = 'adminHandler.php?load_section=product_to_cat&pg=setData&';
    }

	function setPosition ($position) {
		$this->position = $position;
	}

	function setProductsId ($id) {
	    $this->pID = $id;
	}
	function getProductsId () {
        return $this->pID;
	}

	function _get($ID = 0) {
		global $xtPlugin, $db, $language;

		if ($this->position != 'admin') return false;

		if ($ID === 'new') {
               $obj = $this->_set(array(), 'new');
               $ID = $obj->new_id;
		}

		$table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key, 'master_link!=1 and products_id='.$this->getProductsId());
		if ($this->url_data['get_data']){
			$data = $table_data->getData();
		}elseif($this->url_data['edit_id']){
			$data = $table_data->getData($this->url_data['edit_id']);
		}else{
			$data = $table_data->getHeader();
		}

		$obj = new stdClass;
        $obj->totalCount = count($data);
        $obj->data = $data;

        return $obj;
	}


	function setData($dont_die=FALSE) {
        global $db;


        if ($this->url_data['catIds'] && $this->url_data['products_id']) {
            $db->Execute("DELETE FROM " . $this->_table . " WHERE master_link!=1 and products_id = '" . $this->url_data['products_id'] . "'");

            $this->url_data['catIds'] = str_replace(array('[',']','"','\\'), '', $this->url_data['catIds']);
	        $cat_ids = split(',', $this->url_data['catIds']);

	        for ($i = 0; $i < count($cat_ids); $i++) {


	            if ($cat_ids[$i]) {
	            $data = array($this->_master_key => (int)$cat_ids[$i], 'products_id' => $this->url_data['products_id']);
        	        $o = new adminDB_DataSave($this->_table, $data, false, __CLASS__);
        		    $obj = $o->saveDataSet();

	            }
	        }
	    }

        if( $dont_die )
          return $obj;


        header('Content-Type: application/json; charset='._SYSTEM_CHARSET);
        echo json_encode($obj);
        die;
//        return
	}

	function getTreePanel() {
		if ($this->url_data['products_id'])
		$this->setProductsId($this->url_data['products_id']);
	    $root = new PhpExt_Tree_AsyncTreeNode();
        $root->setText("Category")
              ->setId('croot');

        $tl = new PhpExt_Tree_TreeLoader();
        $tl->setDataUrl($this->getTreeUrl);
        if ($this->getProductsId())
        $tl->setBaseParams(array('products_id' => $this->getProductsId()));



        $tp = new PhpExt_Tree_TreePanel();
        $tp->setTitle(__define('TEXT_PRODUCTS_TO_CATEGORIES'))
          ->setRoot($root)
          ->setLoader($tl)
 //         ->setRootVisible(false)
          ->setAutoScroll(true)
//          ->setCollapsible(true)
          ->setAutoWidth(true);

         $tb = $tp->getBottomToolbar();

                $tb->addButton(1,__define('TEXT_SAVE'), $this->_icons_path.'disk.png',new PhpExt_Handler(PhpExt_Javascript::stm("
                 var checked = Ext.encode(tree.getChecked('id'));
                 var conn = new Ext.data.Connection();
                 conn.request({
                 url: '".$this->getSaveUrl."',
                 method:'POST',
                 params: {'products_id': ".$this->getProductsId().", catIds: checked},
                 error: function(responseObject) {
                            Ext.Msg.alert('".__define('TEXT_ALERT')."', '".__define('TEXT_NO_SUCCESS')."');
                          },
                 waitMsg: 'SAVED..',
                 success: function(responseObject) {
                            Ext.Msg.alert('".__define('TEXT_ALERT')."','".__define('TEXT_SUCCESS')."');
                          }
                 });")));
       $tp->setRenderTo(PhpExt_Javascript::variable("Ext.get('".$this->indexID."')"));

        $js = PhpExt_Ext::OnReady(
            PhpExt_Javascript::stm(PhpExt_QuickTips::init()),

            $root->getJavascript(false, "croot"),
        	$tp->getJavascript(false, "tree")

        );


        return '<script type="text/javascript">'. $js .'</script><div id="'.$this->indexID.'"></div>';

	}

	function getNode() {
		if ($this->url_data['products_id'])
		$this->setProductsId($this->url_data['products_id']);

		$table_data = new adminDB_DataRead($this->_table, null, null, $this->_master_key, 'master_link!=1 and products_id='.$this->getProductsId());

		$d = new recursive(TABLE_CATEGORIES, $this->_master_key);

		$categoriesData = $table_data->getData();
		$expand = array();
		if(is_array($categoriesData)){
			foreach ($categoriesData as $cdata) {
			    $path = $d->getPath($cdata[$this->_master_key]);


			    $expand = array_merge($expand, $path);
			    $cat_ids[] = $cdata[$this->_master_key];
			}
		}

        $d->setLangTable(TABLE_CATEGORIES_DESCRIPTION);
        $d->setDisplayKey('categories_name');
        $d->setDisplayLang(true);
        $data = $d->_getLevelItems($this->url_data['node']);

        if(is_array($data)){
	        foreach ($data as $cat_data) {
	            $checked = false;
	            if(is_array($cat_data)&&is_array($cat_ids)){
		            if (in_array($cat_data[$this->_master_key], $cat_ids)) {
		                $checked = true;
		            }
	            }

	            $expanded = false;
	            if (in_array($cat_data[$this->_master_key], $expand)) {
	                $expanded = true;
	            }
	            $new_cats[] = array('id' => $cat_data[$this->_master_key], 'text' => $cat_data[$d->getDisplayKey()], 'checked' => $checked, 'expanded' => $expanded);
	        }
        }
        header('Content-Type: application/json; charset='._SYSTEM_CHARSET);
        return json_encode($new_cats);
	}
}
?>