<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright �2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: class.split_page.php 4047 2010-02-11 14:37:08Z ubo $
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');


class split_page{
	var $split_data;

	/**
	 * return split page result
	 *
	 * @param string $sql sql query
	 * @param int $rows_per_page
	 * @param string $param
	 * @param int $cache_secs
	 * @return split_page
	 */
	function split_page($sql, $rows_per_page, $param='',$cache_secs = 0, $seo_link='true'){
		global $db;

		$pager = new ADODB_Pager($db, $sql, '', $param, 'true', $seo_link);
		if ($cache_secs>0) {
			$pager->cache = $cache_secs;
		}

		$data = $pager->getData($rows_per_page);
        $this->split_data = array('actual_page' => $data['count']['actual_page'], 
                                  'last_page' => $data['count']['last_page'], 
		                          'data' => $data['data'],
								  'count' => $this->formatPagesCount($data['count']),
								  'pages' => $this->formatPages($data['pages'],$data['count']),
								  'total' => $data['data_count']
								 );

	}

	function formatPagesCount($data){
		global $xtPlugin, $db, $template;

			$template = new Template();
			$tpl_data = $data;
			$countData = $template->getTemplate('nav_count_smarty', '/'._SRV_WEB_CORE.'pages/navigation/nav_count.html',$tpl_data);

		return $countData;
	}

	function formatPages($data,$count){
		global $xtPlugin, $db, $template;

			$template = new Template();
			$tpl_data = array_merge($data,$count);
			$pagesData = $template->getTemplate('nav_pages_smarty', '/'._SRV_WEB_CORE.'pages/navigation/nav_pages.html',$tpl_data);

		return $pagesData;
	}

}

?>