<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Enterprise
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright �2007-2008 xt:Commerce GmbH. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~~~~ xt:Commerce VEYTON 4.0 Enterprise IS NOT FREE SOFTWARE ~~~~~~~~~~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # @author Mario Zanier, xt:Commerce GmbH	mzanier@xt-commerce.com
 #
 # @author Matthias Hinsche					mh@xt-commerce.com
 # @author Matthias Benkwitz				mb@xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Bachweg 1, A-6091 Goetzens (AUSTRIA)
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

function _checkIsWriteable($resource) {

	if (!is_writeable($resource)) return false;
	return true;
}

function _checkServerSettings() {
	$setting = array();

	$setting[0]=array('desc'=>_SYSTEM_PHP_VERSION,'check'=>'1');
	$setting[2]=array('desc'=>_SYSTEM_ZLIB,'check'=>'1');
	$setting[4]=array('desc'=>_SYSTEM_CURL,'check'=>'1');
	$setting[6]=array('desc'=>_SYSTEM_GDLIB,'check'=>'1');
	$setting[8]=array('desc'=>_SYSTEM_GDLIB_GIF,'check'=>'1');
//	$setting[10]=array('desc'=>_SYSTEM_SAFE_MODE,'check'=>'1');
	$setting[12]=array('desc'=>_SYSTEM_REG_GLOBALS,'check'=>'1');
	$setting[14]=array('desc'=>_SYSTEM_SESSION_AUTOSTART,'check'=>'1');
	$setting[16]=array('desc'=>_SYSTEM_FILE_UPLOAD,'check'=>'1');
	$setting[18]=array('desc'=>_SYSTEM_MEMORY_LIMIT,'check'=>'1');
	$setting[20]=array('desc'=>_SYSTEM_CHECK_MAGIC_QUOTES,'check'=>'1');
    $setting[21]=array('desc'=>_SYSTEM_CHECK_IMAGE_FTBBOX,'check'=>'1');

	// php version
	$setting[0]['version'] = PHP_VERSION;
	if (version_compare("5.1.2",PHP_VERSION)!='-1') {
		$setting[0]['check']=0;
	}

	// check GDlib
	if (function_exists('gd_info')) {
		$gd_info = gd_info();
		$setting[6]['version'] = $gd_info['GD Version'];

		if ($gd_info['GIF Read Support']!='1' or $gd_info['GIF Create Support']!='1') {
			$setting[8]['check']=0;
		}

	} else {
		$setting[6]['check']=0;
		$setting[6]['version'] = '- missing -';

		$setting[8]['check']=0;
		$setting[8]['version'] = '- missing -';
	}

	// check safe mode
	if (ini_get('safe_mode')==1) {
		$setting[10]['check']=0;
	}

	// check register_globals
	if (ini_get('register_globals')==1) {
		$setting[12]['check']=0;
	}

	// session auto start
	if (ini_get('session.auto_start')==1) {
		$setting[14]['check']=0;
	}

	// file uploads
	if (ini_get('file_uploads')==0) {
		$setting[16]['check']=0;
	}
	
	// magic_quotes_gpc
	if (ini_get('magic_quotes_gpc')==0) {
		$setting[20]['check']=0;
	}

	// max_execution_time
	// memory_limit
	$limit = ini_get('memory_limit');
	$setting[18]['version']=$limit;
	$limit=(int)$limit;
	if ($limit<32) {
		$setting[18]['check']=0;
	}
    
    // check imageftbbox function
    if (!function_exists('imageftbbox')) {
       $setting[21]['check']=0;  
    }


	return $setting;

}

function _redirect($url) {
	$url = eregi_replace("[\r\n]+(.*)$", "", $url);
	$url = html_entity_decode($url);
	header('Location: ' . $url);
	exit;
}


function _pageLink($page,$params='') {
	$link = 'index.php?page='.$page.'&'.session_name().'='.session_id().'&'.$params;
	return $link;
}

function _installSQL($filename,$prefix='') {
	global $idb;

	// open sql
	$filename = _SRV_WEBROOT.'xtInstaller/sql/'.$filename;
	$sql_content = _getFileContent($filename);

	// replace windows linefeeds
	$sql_content = str_replace("\r\n","\n",$sql_content);
	
	$queries = array();

	$chars = strlen($sql_content);

	for ($i=0;$i<$chars;$i++) {

		// check if char is ; and next \n
		if ($sql_content[$i]==';' && $sql_content[$i+1]=="\n") {
			$query.=$sql_content[$i];
			$queries[]=$query;
			$query = '';
			$i++;
		} else {

			if ($sql_content[$i]=='-' && $sql_content[$i+1]=='-') {

				// skip to next \n
				for ($ii=$i;$ii<$chars;$ii++) {

					if ($sql_content[$ii]=="\n") {
						break;
					} else {
						$i++;
					}

				}


			} else {
				if (!isset($query)) $query='';
				$query.=$sql_content[$i];
			}

		}

	}


	foreach ($queries as $key => $val) {

		$query = trim($val);
		$query = str_replace('##_',$prefix,$query);

		// ok, now search vor OTHER INSERT INTO statements, and break them up
		if (substr($query,0,6)=='INSERT') {
			$check_qry = substr($query,7);

			if (strstr($check_qry,'INSERT')) {
				$qry = explode('INSERT',$check_qry);
				foreach ($qry as $k => $v) {
					$queries[]='INSERT '.$v;
				}
				unset ($queries[$key]);
			} else {
				$queries[$key]=$query;
			}

		} else {
			$queries[$key]=$query;
		}

	}


	foreach ($queries as $key => $val) {
		try {
			$idb->Execute($val);
		} catch (exception $e) {
            echo $val;
			return $e;
		}
	}

	return -1;

}

function _getFileContent($filename) {
	$handle = fopen($filename, 'rb');
	$content = fread($handle, filesize($filename));
	fclose($handle);
	return $content;

}

function _installMailTemplates($lng,$max_id=0) {
	global $idb;
	if ($max_id==0) return false;

	$mail_dir = _SRV_WEBROOT.'xtInstaller/sql/mails_'.$lng;
	for ($i=1;$i<$max_id+1;$i++) {

		if (file_exists($mail_dir.'/'.$i.'_'.$lng.'_txt.txt')) {

			$file_prefix = $i.'_'.$lng.'_';

			$html_content = _getFileContent($mail_dir.'/'.$file_prefix.'html.txt');
			$txt_content = _getFileContent($mail_dir.'/'.$file_prefix.'txt.txt');
			$subject = _getFileContent($mail_dir.'/'.$file_prefix.'subject.txt');

			$insert_array=array();
			$insert_array['tpl_id']=$i;
			$insert_array['language_code']=$lng;
			$insert_array['mail_body_html']=$html_content;
			$insert_array['mail_body_txt']=$txt_content;
			$insert_array['mail_subject']=$subject;
			try {
				$idb->AutoExecute(TABLE_MAIL_TEMPLATES_CONTENT,$insert_array);
			} catch (exception $e) {
				return $e->msg;
			}

		}
	}

	return true;

}

function _genPass() {
	$newpass = "";
	$laenge=6;
	$string="ABCDEFGHIJKLMNPQRSTUVWXYZabcdefghijklmnpqrstuvwxyz123456789";

	mt_srand((double)microtime()*1000000);

	for ($i=1; $i <= $laenge; $i++) {
		$newpass .= substr($string, mt_rand(0,strlen($string)-1), 1);
	}
	return $newpass;
}



?>